; 
    include \masm32\include\masm32rt.inc
    include \masm32\include\gdiplus.inc
    includelib \masm32\lib\gdiplus.lib
    include \masm32\macros\ucmacros.asm

    GdiplusStartupInput STRUCT
      GdiplusVersion           DWORD ?
      DebugEventCallback       DWORD ?
      SuppressBackgroundThread DWORD ?
      SuppressExternalCodecs   DWORD ?
    GdiplusStartupInput ENDS

    ImageCodecInfo STRUCT
      ClassID           CLSID <>
      FormatID          GUID <>
      CodecName         DWORD ?
      DllName           DWORD ?
      FormatDescription DWORD ?
      FilenameExtension DWORD ?
      MimeType          DWORD ?
      Flags             DWORD ?
      Version           DWORD ?
      SigCount          DWORD ?
      SigSize           DWORD ?
      SigPattern        DWORD ?
      SigMask           DWORD ?
    ImageCodecInfo ENDS

; 
    .data
      token               dd 0
      image               dd 0
      numEncoders         dd 0
      sizeImageCodecInfo  dd 0
      pImageCodecInfo     dd 0
      gdipsi              GdiplusStartupInput <1>  ; version must be 1
    .code
; 
start:
; 

    print "GdiplusStartup rv "
    invoke GdiplusStartup, ADDR token, ADDR gdipsi, NULL
    print ustr$(eax),13,10

    print "GdipLoadImageFromFile rv "
    invoke GdipLoadImageFromFile, uni$("sample.bmp"), ADDR image
    print ustr$(eax),13,10

    print "GdipGetImageEncodersSize rv "
    invoke GdipGetImageEncodersSize, ADDR numEncoders,
                                     ADDR sizeImageCodecInfo
    print ustr$(eax),13,10

    print "numEncoders "
    print ustr$(numEncoders),13,10
    print "sizeImageCodecInfo "
    print ustr$(sizeImageCodecInfo)," bytes",13,10

    mov pImageCodecInfo, alloc(sizeImageCodecInfo)

    print "GdipGetImageEncoders rv "
    invoke GdipGetImageEncoders, numEncoders, sizeImageCodecInfo,
                                 pImageCodecInfo
    print ustr$(eax),13,10

    xor ebx, ebx
    mov esi, pImageCodecInfo
    .WHILE ebx < numEncoders
      invoke crt_printf, chr$("%S%c"), [esi].ImageCodecInfo.MimeType, 10
      .IF ucmp$([esi].ImageCodecInfo.MimeType, uni$("image/jpeg") )
        print "GdipSaveImageToFile rv "
        invoke GdipSaveImageToFile, image, uni$("sample.jpg"),
                                    esi, NULL
        print ustr$(eax),13,10
      .ENDIF
      add esi, SIZEOF ImageCodecInfo
      inc ebx
    .ENDW

    print "GdipDisposeImage rv "
    invoke GdipDisposeImage, image
    print ustr$(eax),13,10

    print "GdiplusShutdown rv "
    invoke GdiplusShutdown, token
    print ustr$(eax),13,10

    free pImageCodecInfo

    inkey "Press any key to exit..."
    exit
; 
end start

%StatusOk = 0
%StatusGenericError = 1
%StatusInvalidParameter = 2
%StatusOutOfMemory = 3
%StatusObjectBusy = 4
%StatusInsufficientBuffer = 5
%StatusNotImplemented = 6
%StatusWin32Error = 7
%StatusWrongState = 8
%StatusAborted = 9
%StatusFileNotFound = 10
%StatusValueOverflow = 11
%StatusAccessDenied = 12
%StatusUnknownImageFormat = 13
%StatusFontFamilyNotFound = 14
%StatusFontStyleNotFound = 15
%StatusNotTrueTypeFont = 16
%StatusUnsupportedGdiplusVersion = 17
%StatusGdiplusNotInitialized = 18
%StatusPropertyNotFound = 19
%StatusPropertyNotSupported = 20
